diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.44/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.43/src/wifi/test/spectrum-wifi-phy-test.cc	2024-10-09 16:41:10.136656800 -0700
+++ ns-3.44/src/wifi/test/spectrum-wifi-phy-test.cc	2025-03-09 16:55:49.807372600 -0700
@@ -1482,9 +1493,9 @@
                         channelNumbers);
 
     // create info about interference to generate
-    BandInfo bandInfo{.fl = (interferenceCenterFrequency - (interferenceBandWidth / 2)) * 1e6,
-                      .fc = interferenceCenterFrequency * 1e6,
-                      .fh = (interferenceCenterFrequency + (interferenceBandWidth / 2)) * 1e6};
+    BandInfo bandInfo{.fl = MHzToHz(interferenceCenterFrequency - (interferenceBandWidth / 2)),
+                      .fc = MHzToHz(interferenceCenterFrequency),
+                      .fh = MHzToHz(interferenceCenterFrequency + (interferenceBandWidth / 2))};
     auto spectrumInterference = Create<SpectrumModel>(Bands{bandInfo});
     auto interferencePsd = Create<SpectrumValue>(spectrumInterference);
     Watt_u interferencePower{0.1};
@@ -1523,7 +1534,7 @@
     //                   │          5250 MHz, 160 MHz           │
     //                   └──────────────────────────────────────┘
     //
-    RunOne({50}, 5290, 80, false);
+    RunOne({50}, MHz_u{5290}, MHz_u{80}, false);
 
     // Test transmission over non-contiguous 160 MHz (i.e. 80+80MHz) and same interference as in
     // previous run. The reception should succeed because the interference is located between the
@@ -1538,7 +1549,7 @@
     //                   │80+80MHz segment 0│                             │80+80MHz segment 1│
     //                   └──────────────────┘                             └──────────────────┘
     //
-    RunOne({42, 106}, 5290, 80, true);
+    RunOne({42, 106}, MHz_u{5290}, MHz_u{80}, true);
 
     // Test transmission over non-contiguous 160 MHz (i.e. 80+80MHz) and interference generated on
     // the first segment of the channel width (channel 42, i.e. center frequency 5210 and bandwidth
@@ -1554,7 +1565,7 @@
     //                   │80+80MHz segment 0│                             │80+80MHz segment 1│
     //                   └──────────────────┘                             └──────────────────┘
     //
-    RunOne({42, 106}, 5210, 80, false);
+    RunOne({42, 106}, MHz_u{5210}, MHz_u{80}, false);
 
     // Test transmission over non-contiguous 160 MHz (i.e. 80+80MHz) and interference generated on
     // the second segment of the channel width (channel 42, i.e. center frequency 5210 and bandwidth
@@ -1570,16 +1581,16 @@
     //                   │80+80MHz segment 0│                             │80+80MHz segment 1│
     //                   └──────────────────┘                             └──────────────────┘
     //
-    RunOne({42, 106}, 5530, 80, false);
+    RunOne({42, 106}, MHz_u{5530}, MHz_u{80}, false);
 
     Simulator::Destroy();
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Spectrum Wifi Phy Multiple Spectrum Test
+ * @brief Spectrum Wifi Phy Multiple Spectrum Test
  *
  * This test is testing the ability to plug multiple spectrum channels to the spectrum wifi PHY.
  * It considers 4 TX-RX PHY pairs that are independent from each others and are plugged to different
@@ -1610,9 +1621,9 @@
     /**
      * Constructor
      *
-     * \param trackSignalsInactiveInterfaces flag to indicate whether signals coming from inactive
+     * @param trackSignalsInactiveInterfaces flag to indicate whether signals coming from inactive
      * spectrum PHY interfaces shall be tracked during the test
-     * \param chanSwitchScenario the channel switching scenario to consider for the test
+     * @param chanSwitchScenario the channel switching scenario to consider for the test
      */
     SpectrumWifiPhyMultipleInterfacesTest(bool trackSignalsInactiveInterfaces,
                                           ChannelSwitchScenario chanSwitchScenario);
@@ -1625,11 +1636,11 @@
     /**
      * Switch channel function
      *
-     * \param phy the PHY to switch
-     * \param band the PHY band to use
-     * \param channelNumber number the channel number to use
-     * \param channelWidth the channel width to use
-     * \param listenerIndex index of the listener for that PHY, if PHY is a RX PHY
+     * @param phy the PHY to switch
+     * @param band the PHY band to use
+     * @param channelNumber number the channel number to use
+     * @param channelWidth the channel width to use
+     * @param listenerIndex index of the listener for that PHY, if PHY is a RX PHY
      */
     void SwitchChannel(Ptr<SpectrumWifiPhy> phy,
                        WifiPhyBand band,
@@ -1640,17 +1651,17 @@
     /**
      * Send PPDU function
      *
-     * \param phy the PHY to transmit the signal
-     * \param txPower the power to transmit the signal (this is also the received power since we do
+     * @param phy the PHY to transmit the signal
+     * @param txPower the power to transmit the signal (this is also the received power since we do
      * not have propagation loss to simplify) \param payloadSize the payload size in bytes
      */
     void SendPpdu(Ptr<SpectrumWifiPhy> phy, dBm_u txPower, uint32_t payloadSize);
 
     /**
      * Callback triggered when a packet is received by a PHY
-     * \param index the index to identify the RX PHY
-     * \param packet the received packet
-     * \param rxPowersW the received power per channel band in watts
+     * @param index the index to identify the RX PHY
+     * @param packet the received packet
+     * @param rxPowersW the received power per channel band in watts
      */
     void RxCallback(std::size_t index,
                     Ptr<const Packet> packet,
@@ -1658,31 +1669,31 @@
 
     /**
      * Receive success function
-     * \param index index of the RX STA
-     * \param psdu the PSDU
-     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
-     * \param txVector the transmit vector
-     * \param statusPerMpdu reception status per MPDU
+     * @param index index of the RX STA
+     * @param psdu the PSDU
+     * @param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * @param txVector the transmit vector
+     * @param statusPerMpdu reception status per MPDU
      */
     void RxSuccess(std::size_t index,
                    Ptr<const WifiPsdu> psdu,
                    RxSignalInfo rxSignalInfo,
-                   WifiTxVector txVector,
-                   std::vector<bool> statusPerMpdu);
+                   const WifiTxVector& txVector,
+                   const std::vector<bool>& statusPerMpdu);
 
     /**
      * Receive failure function
-     * \param index index of the RX STA
-     * \param psdu the PSDU
+     * @param index index of the RX STA
+     * @param psdu the PSDU
      */
     void RxFailure(std::size_t index, Ptr<const WifiPsdu> psdu);
 
     /**
      * Schedule now to check the interferences
-     * \param phy the PHY for which the check has to be executed
-     * \param freqRange the frequency range for which the check has to be executed
-     * \param band the band for which the check has to be executed
-     * \param interferencesExpected flag whether interferences are expected to have been tracked
+     * @param phy the PHY for which the check has to be executed
+     * @param freqRange the frequency range for which the check has to be executed
+     * @param band the band for which the check has to be executed
+     * @param interferencesExpected flag whether interferences are expected to have been tracked
      */
     void CheckInterferences(Ptr<SpectrumWifiPhy> phy,
                             const FrequencyRange& freqRange,
@@ -1691,9 +1702,9 @@
 
     /**
      * Check the interferences
-     * \param phy the PHY for which the check has to be executed
-     * \param band the band for which the check has to be executed
-     * \param interferencesExpected flag whether interferences are expected to have been tracked
+     * @param phy the PHY for which the check has to be executed
+     * @param band the band for which the check has to be executed
+     * @param interferencesExpected flag whether interferences are expected to have been tracked
      */
     void DoCheckInterferences(Ptr<SpectrumWifiPhy> phy,
                               const WifiSpectrumBandInfo& band,
@@ -1702,13 +1713,13 @@
     /**
      * Verify results
      *
-     * \param index the index to identify the RX PHY to check
-     * \param expectedNumRx the expected number of RX events for that PHY
-     * \param expectedNumRxSuccess the expected amount of successfully received packets
-     * \param expectedRxBytes the expected amount of received bytes
-     * \param expectedFrequencyRangeActiveRfInterface the expected frequency range (in MHz) of the
+     * @param index the index to identify the RX PHY to check
+     * @param expectedNumRx the expected number of RX events for that PHY
+     * @param expectedNumRxSuccess the expected amount of successfully received packets
+     * @param expectedRxBytes the expected amount of received bytes
+     * @param expectedFrequencyRangeActiveRfInterface the expected frequency range (in MHz) of the
      * active RF interface
-     * \param expectedConnectedPhysPerChannel the expected number of PHYs attached for each spectrum
+     * @param expectedConnectedPhysPerChannel the expected number of PHYs attached for each spectrum
      * channel
      */
     void CheckResults(std::size_t index,
@@ -1721,11 +1732,11 @@
     /**
      * Verify CCA indication reported by a given PHY
      *
-     * \param index the index to identify the RX PHY to check
-     * \param expectedCcaBusyIndication flag to indicate whether a CCA BUSY notification is expected
-     * \param switchingDelay delay between the TX has started and the time RX switched to the TX
+     * @param index the index to identify the RX PHY to check
+     * @param expectedCcaBusyIndication flag to indicate whether a CCA BUSY notification is expected
+     * @param switchingDelay delay between the TX has started and the time RX switched to the TX
      * channel
-     * \param propagationDelay the propagation delay
+     * @param propagationDelay the propagation delay
      */
     void CheckCcaIndication(std::size_t index,
                             bool expectedCcaBusyIndication,
@@ -1735,8 +1746,8 @@
     /**
      * Verify rxing state of the interference helper
      *
-     * \param phy the PHY to which the interference helper instance is attached
-     * \param rxingExpected flag whether the interference helper is expected to be in rxing state or
+     * @param phy the PHY to which the interference helper instance is attached
+     * @param rxingExpected flag whether the interference helper is expected to be in rxing state or
      * not
      */
     void CheckRxingState(Ptr<SpectrumWifiPhy> phy, bool rxingExpected);
@@ -1814,7 +1825,7 @@
                           1,
                           1,
                           0,
-                          20,
+                          MHz_u{20},
                           false,
                           false};
     Ptr<Packet> pkt = Create<Packet>(payloadSize);
@@ -1851,8 +1862,8 @@
 SpectrumWifiPhyMultipleInterfacesTest::RxSuccess(std::size_t index,
                                                  Ptr<const WifiPsdu> psdu,
                                                  RxSignalInfo rxSignalInfo,
-                                                 WifiTxVector txVector,
-                                                 std::vector<bool> /*statusPerMpdu*/)
+                                                 const WifiTxVector& txVector,
+                                                 const std::vector<bool>& /*statusPerMpdu*/)
 {
     NS_LOG_FUNCTION(this << index << *psdu << rxSignalInfo << txVector);
     m_countRxSuccess.at(index)++;
@@ -1895,7 +1906,7 @@
     phy->GetAttribute("InterferenceHelper", ptr);
     auto interferenceHelper = DynamicCast<InterferenceHelper>(ptr.Get<InterferenceHelper>());
     NS_ASSERT(interferenceHelper);
-    const auto energyDuration = interferenceHelper->GetEnergyDuration(0, band);
+    const auto energyDuration = interferenceHelper->GetEnergyDuration(Watt_u{0}, band);
     NS_TEST_ASSERT_MSG_EQ(energyDuration.IsStrictlyPositive(),
                           interferencesExpected,
                           "Incorrect interferences detection");
@@ -2149,7 +2160,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    const dBm_u ccaEdThreshold = -62.0; ///< CCA-ED threshold
+    const dBm_u ccaEdThreshold{-62.0}; ///< CCA-ED threshold
     const auto txAfterChannelSwitchDelay =
         MicroSeconds((m_chanSwitchScenario == ChannelSwitchScenario::BEFORE_TX)
                          ? 250
@@ -2182,7 +2193,7 @@
                             &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                             this,
                             txPpduPhy,
-                            0,
+                            dBm_u{0},
                             1000);
         for (std::size_t j = 0; j < 4; ++j)
         {
@@ -2220,7 +2231,7 @@
                             &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                             this,
                             txPpduPhy,
-                            0,
+                            dBm_u{0},
                             1000);
         const auto& expectedFreqRange = txPpduPhy->GetCurrentFrequencyRange();
         for (std::size_t j = 0; j < 4; ++j)
@@ -2276,7 +2287,7 @@
                             &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                             this,
                             txPpduPhy,
-                            0,
+                            dBm_u{0},
                             1000);
         for (std::size_t j = 0; j < 4; ++j)
         {
@@ -2312,24 +2323,24 @@
     }
 
     // verify CCA indication when switching to a channel with an ongoing transmission
-    for (const dBm_u txPower : {-60.0 /* above CCA-ED */, -70.0 /* below CCA-ED */})
+    for (const auto txPower : {dBm_u{-60} /* above CCA-ED */, dBm_u{-70} /* below CCA-ED */})
     {
         for (std::size_t i = 0; i < 4; ++i)
         {
             for (std::size_t j = 0; j < 4; ++j)
             {
                 auto txPpduPhy = m_txPhys.at(i);
-                const auto startChannel =
-                    WifiPhyOperatingChannel::FindFirst(txPpduPhy->GetPrimaryChannelNumber(20),
-                                                       0,
-                                                       20,
-                                                       WIFI_STANDARD_80211ax,
-                                                       txPpduPhy->GetPhyBand());
-                for (auto bw = txPpduPhy->GetChannelWidth(); bw >= 20; bw /= 2)
+                const auto startChannel = WifiPhyOperatingChannel::FindFirst(
+                    txPpduPhy->GetPrimaryChannelNumber(MHz_u{20}),
+                    MHz_u{0},
+                    MHz_u{20},
+                    WIFI_STANDARD_80211ax,
+                    txPpduPhy->GetPhyBand());
+                for (auto bw = txPpduPhy->GetChannelWidth(); bw >= MHz_u{20}; bw /= 2)
                 {
                     const auto& channelInfo =
                         (*WifiPhyOperatingChannel::FindFirst(0,
-                                                             0,
+                                                             MHz_u{0},
                                                              bw,
                                                              WIFI_STANDARD_80211ax,
                                                              txPpduPhy->GetPhyBand(),
@@ -2393,7 +2404,7 @@
                                 &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                                 this,
                                 txPpduPhy,
-                                20,
+                                dBm_u{20},
                                 500);
 
             // switch channel to other band
@@ -2414,7 +2425,7 @@
                                 &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                                 this,
                                 txPpduPhy,
-                                0,
+                                dBm_u{0},
                                 1000);
 
             // switch back to initial band during PHY header reception
@@ -2435,7 +2446,7 @@
                                 &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                                 this,
                                 txPpduPhy,
-                                0,
+                                dBm_u{0},
                                 1500);
 
             // check results
@@ -2481,7 +2492,7 @@
                                 &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                                 this,
                                 txPpduPhy,
-                                20,
+                                dBm_u{20},
                                 500);
 
             // switch channel back to previous channel before preamble detection is finished:
@@ -2514,7 +2525,7 @@
                                 &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                                 this,
                                 txPpduPhy,
-                                20,
+                                dBm_u{20},
                                 1000);
 
             // second transmission on 5 GHz low band  with high power a bit later:
@@ -2524,7 +2535,7 @@
                                 &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                                 this,
                                 txPpduPhy,
-                                20,
+                                dBm_u{20},
                                 1000);
 
             // restore channel for TX PHY index 2
@@ -2556,7 +2567,7 @@
                                 &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                                 this,
                                 txPpduPhy,
-                                0,
+                                dBm_u{0},
                                 1500);
 
             // check results
@@ -2583,10 +2594,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Spectrum Wifi Phy Interfaces Helper Test
+ * @brief Spectrum Wifi Phy Interfaces Helper Test
  *
  * This test checks the expected interfaces are added to the spectrum PHY instances
  * created by the helper.
@@ -2772,10 +2783,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Spectrum Wifi Phy Test Suite
+ * @brief Spectrum Wifi Phy Test Suite
  */
 class SpectrumWifiPhyTestSuite : public TestSuite
 {
